#!/usr/bin/perl
use strict;
use warnings;
use utf8;
use Carp;																	# Gestion des erreurs de syntaxe
use File::Spec;														# Permet une meilleure gestion des noms des chemins sous tous les OS
use Config::Std;													# Lecture/ecriture d'un fichier .ini
use Win32::MediaPlayer;										# Pour jouer un fichier son

my $winmm = new Win32::MediaPlayer;
Win32::API::Struct->typedef(SYSTEM_POWER_STATUS => qw
(
  BYTE ACLineStatus;
  BYTE BatteryFlag;
  BYTE BatteryLifePercent;
  BYTE Reserved1;
  DWORD BatteryLifeTime;
  DWORD BatteryFullLifeTime;
));

my $Power = Win32::API->new('kernel32','BOOL GetSystemPowerStatus(SYSTEM_POWER_STATUS status)');
my $Status = Win32::API::Struct->new('SYSTEM_POWER_STATUS');
$Power->Call($Status);

my $RepBase = 'C:\_Mail';

# Lecture du fichier de configuration
my $Batterie = File::Spec->catfile( $RepBase, 'Batterie.ini' );
my %Batterie_Ini;
if ( -e $Batterie ) {
  read_config $Batterie => %Batterie_Ini;
}
else {
  %Batterie_Ini = (
  	'GLOBAL'				=> {
  		Debug					=> 'NON',
  		Batterie			=> 'OUI',
  		Batterie_75		=> 'OUI',
  		Batterie_50		=> 'OUI',
  		Batterie_25		=> 'OUI',
  	},    
  );
}
# Programme

if ( $Status->{ACLineStatus} == 0 && $Batterie_Ini{GLOBAL}{Batterie} eq 'OUI' ) {
	my $FicSon = File::Spec->catfile( $RepBase, 'batterie.mp3');
	$winmm->load($FicSon);
	$winmm->play;
	sleep (4);
	$winmm->volume(50);
	$winmm->close;
}

if ( $Status->{ACLineStatus} == 0 && $Batterie_Ini{GLOBAL}{Batterie} eq 'OUI' ) {
	if ( $Batterie_Ini{GLOBAL}{Batterie_75} && $Status->{BatteryLifePercent} < 75 && $Status->{BatteryLifePercent} >= 50 ) {
		my $FicSon = File::Spec->catfile( $RepBase, 'batterie-75.mp3');
		$winmm->load($FicSon);
		$winmm->play;
		sleep (4);
		$winmm->volume(50);
		$winmm->close;
	}
}
if ( $Status->{ACLineStatus} == 0 && $Batterie_Ini{GLOBAL}{Batterie} eq 'OUI' ) {
	if ( $Batterie_Ini{GLOBAL}{Batterie_50} && $Status->{BatteryLifePercent} < 50 && $Status->{BatteryLifePercent} >= 25 ) {
		my $FicSon = File::Spec->catfile( $RepBase, 'batterie-50.mp3');
		$winmm->load($FicSon);
		$winmm->play;
		sleep (4);
		$winmm->volume(50);
		$winmm->close;
	}
}
if ( $Status->{ACLineStatus} == 0 && $Batterie_Ini{GLOBAL}{Batterie} eq 'OUI' ) {
	if ( $Batterie_Ini{GLOBAL}{Batterie_25} && $Status->{BatteryLifePercent} < 25 ) {
		my $FicSon = File::Spec->catfile( $RepBase, 'batterie-25.mp3');
		$winmm->load($FicSon);
		$winmm->play;
		sleep (10);
		$winmm->volume(50);
		$winmm->close;
	}
}
print "Batterie = $Status->{BatteryLifePercent} %\n";
exit (0);
