#! perl
use warnings;
use strict;
use utf8;
use Win32;																# Pour GetTickCount
use Win32::Process::List;									# Liste des processus en cours
use Win32::Process;												# Pour tuer un processus
use Config::Std;													# Lecture/ecriture d'un fichier .ini
use File::Copy;														# Pour effectuer des copy de fichiers
use File::Spec;														# Permet une meilleure gestion des noms des chemins sous tous les OS
use File::Path;														# Gestion des répertoires
use Getopt::Long;													# Pour la gestion des paramètres passés en ligne de commande
use Win32::MediaPlayer;										# Permet de jouer des sons

ActiverAccentDOS();

my ( $OptPerl ) = ();
GetOptions( 
  'OptPerl=s' => \$OptPerl,      # Option de lancement perl : perl.exe ou wperl.exe
);
if ( ! defined $OptPerl ) {
  print "usage : perl Kill_Process.pl --OptPerl perl|wperl\n";
  exit;
}
if ( $OptPerl ne 'perl' && $OptPerl ne 'wperl' ) {
  print "usage : perl Kill_Process.pl --OptPerl perl|wperl\n";
  exit;
}

my $RepBase = 'C:\Mail';
my $winmm = new Win32::MediaPlayer;
my $FicSon = File::Spec->catfile( $RepBase, 'coin_up.mp3' );
$winmm->load($FicSon);
$winmm->play;
sleep (1);
$winmm->volume(100);
$winmm->close;

my $Fail = 0;
my $Message = "";
my $fichier_Log = File::Spec->catfile( $RepBase, 'PROC.ano' );
my $fichier_Log_Desktop = File::Spec->catfile( 'C:\Users\Michel\Desktop', 'PROC.ano' );
open(LOG,'>:utf8', $fichier_Log)
	or die (Log("Erreur sur ouverture fichier Log : $fichier_Log\n"), $Fail++, exit);
	
my $Date_Heure = date();
Log ("\n$Date_Heure\n");

my $Demarrage = Win32::GetTickCount();
my $Debut = $Demarrage;
my $Msec = $Demarrage % 1000;
$Demarrage = ($Demarrage - $Msec) / 1000;
my $Sec = $Demarrage % 60;
$Demarrage = ($Demarrage - $Sec) / 60;
my $Min = $Demarrage % 60;
$Demarrage = ($Demarrage - $Min) / 60;
Log ("\nSystème démarré depuis : $Demarrage h $Min mn $Sec s $Msec ms\n");

my $FicIni = File::Spec->catfile( $RepBase, 'Process.ini' );
my %Process;
if ( -e $FicIni ) {
  read_config $FicIni => %Process;
}
else {
  %Process = (
  	'GLOBAL'	=> {
  		            Debug => 'NON',
  		             Kill => 'OUI',
  		         Controle => 'OUI',
  		             Info => 'OUI',
  		          NbFirst => 80,
  		           NbNext => 80,
  		        TempoKill => 120000,
  		    InitListFirst => '0UI',
  		DateInitListFirst => 'lib',
  		     InitListNext => 'OUI',
  		DateInitListFirst => 'lib',
  		          DelTemp => 'OUI',
  	},
  	'OLD'	=> {
  		Proc	=> 'Skype.exe',
  	},
  	'KILL'	=> {
  		Proc	=> 'Skype.exe',
  	},
    'LISTFIRST'	=> {
      Proc	=> 'Skype.exe',
    },
  );
}

my @ListFirstIni = split (/\n/,$Process{LISTFIRST}{Proc});
my @ListNextIni = split (/\n/,$Process{LISTNEXT}{Proc});
my @KillIni = split (/\n/, $Process{KILL}{Proc});
my $Proc = Win32::Process::List->new();
my %ListProc = $Proc->GetProcesses();
my $NbProc = keys (%ListProc);
Log ("\nNombre de processus = $NbProc\n");

if ( $Process{GLOBAL}{Debug} eq 'OUI' ) {
	Log ("LISTFIRSTINI : \n@ListFirstIni\n\n");
	Log ("LISTNEXTINI : \n@ListNextIni\n\n");
	Log ("KILLINI : \n@KillIni\n\n");
}

Log ("\n\n################################\n");
Log ("       Processus à tuer        :\n\n");
Log ((join("\n", @KillIni)));

# Contrôle cohérence de @KillIni
if ( $Process{GLOBAL}{Info} eq 'OUI' ) {
	Log ("\n\n################################\n");
	Log (" Contrôle cohérence de KILLINI :\n\n");
	my @TabKillDoub = (sort values %ListProc );
	my @TabKill = doublons_grep( \@TabKillDoub );
	my @ListDoub = sort (@KillIni);
	my @List = doublons_grep( \@ListDoub );
	foreach my $Name (@List) {
		if ( ! grep {$_ eq  $Name} @TabKill ) {
			$Message = sprintf "INFO : %35s présent dans KILL, n'existe pas en tant que processus\n", $Name;
			Log ($Message);
		}
	}
	Log ("\n################################\n");
}

my $ListFirstExist = "";
my $ListNextExist  = "";
Log (" KILL  &   A N O M A L i E S   :\n\n");
foreach my $Pid (sort { $ListProc{$a} cmp $ListProc{$b} } keys %ListProc ) {
	my $Name = $ListProc{$Pid};
	my $ExitCode;
	if ( $Process{GLOBAL}{Kill} eq 'OUI' ) {
		if ( grep {$_ eq  $Name} @KillIni ) {
			Win32::Process::KillProcess ($Pid, \$ExitCode);
			$Message = sprintf "\n%4d %25s Tué\n\n" ,$Pid, $ListProc{$Pid};
			Log ($Message);
			$Fail++;
		}
	}
   
	if ( $Process{GLOBAL}{Controle} eq 'OUI' ) {
		# Controle au boot du PC
		if ( $Debut < $Process{GLOBAL}{TempoKill} ) {
			if ( grep {$_ eq  $Name} @ListFirstIni ) {			
				if ( $Process{GLOBAL}{Debug} eq 'OUI' ) {
					$Message = sprintf "%4d %25s Présent dans ListFirstIni\n" ,$Pid, $ListProc{$Pid};
					Log ($Message);
				}
			} else {
				$ListFirstExist = "$ListFirstExist$Name\n";
				$Message = sprintf "%4d %25s Absent  dans ListFirstIni\n" ,$Pid, $ListProc{$Pid};
				Log ($Message);
				$Fail++;
			}
		}
		
		# Controle après TempoKill de fonctionnement du PC (2mn)
		if ( $Debut >= $Process{GLOBAL}{TempoKill} ) {
			if ( grep {$_ eq  $Name} @ListNextIni ) {
				if ( $Process{GLOBAL}{Debug} eq 'OUI' ) {
					$Message = sprintf "%4d %25s Présent dans ListNextIni\n" ,$Pid, $ListProc{$Pid};
					Log ($Message);
				}
			} else {
				$ListNextExist = "$ListNextExist$Name\n";
				$Message = sprintf "%4d %25s Absent  dans ListNextIni\n" ,$Pid, $ListProc{$Pid};
				Log ($Message);
				$Fail++;
			}
		}
	}
}

# Contrôle cohérence de @ListNextIni
if ( $Process{GLOBAL}{Info} eq 'OUI' ) {
	Log ("\n\n################################\n");
	Log ("Contrôle cohérence de LISTNEXT :\n\n");
	my @TabProcDoub = (sort values %ListProc );
	my @TabProc = doublons_grep( \@TabProcDoub );
	my @ListDoub = sort (@ListNextIni);
	my @List = doublons_grep( \@ListDoub );
	foreach my $Name (@List) {
		if ( ! grep {$_ eq  $Name} @TabProc ) {
			$Message = sprintf "INFO : %35s présent dans LISTNEXT, n'existe pas en tant que processus\n", $Name;
			Log ($Message);
		}
	}
	Log ("\nCes procces n'ont pas encore été lançés !\n");
	Log ("#########################################\n\n");
}

if ( $Process{GLOBAL}{Debug} eq 'OUI' ) {
	Log ("LISTFIRSTEXIST :\n$ListFirstExist\n");
	Log ("LISTNEXTEXIST :\n$ListNextExist\n\n");
}

if ( $Process{GLOBAL}{DelTemp} eq 'OUI' ) {
	rmtree ( ['C:/Users/Michel/AppData/Local/Temp'] );
	Log ("C:/Users/Michel/AppData/Local/Temp purgé !\n");
}

#        Initialisation de Process.ini
#############################################
#
# Pour initialiser $ListFirstExist dans Process.ini
#
%ListProc = reverse %ListProc;
if ( $Process{GLOBAL}{InitListFirst} eq 'OUI' ) {
	$ListFirstExist = "";
	
	foreach my $Name (sort keys %ListProc ) {
		$ListFirstExist = "$ListFirstExist$Name\n";
	}
	$Process{GLOBAL}{DateInitListFirst} = $Date_Heure;
	$Process{LISTFIRST}{Proc} = $ListFirstExist;
	write_config %Process, $FicIni;
}

#############################################
#
# Pour initialiser $ListNextExist dans Process.ini
#
if ( $Process{GLOBAL}{InitListNext} eq 'OUI' ) {
	$ListNextExist = "";
	foreach my $Name (sort keys %ListProc ) {
		$ListNextExist = "$ListNextExist$Name\n";
	}
	$Process{GLOBAL}{DateInitListNext} = $Date_Heure;
	$Process{LISTNEXT}{Proc} = $ListNextExist;
	write_config %Process, $FicIni;
}


close (LOG);

if ($Fail) {
	$FicSon = File::Spec->catfile( $RepBase, 'proc.mp3' );
	$winmm->load($FicSon);
	$winmm->play;
	sleep (1);
	$winmm->volume(100);
	$winmm->close;
}

$FicSon = File::Spec->catfile( $RepBase, 'coin_down.mp3' );
$winmm->load($FicSon);
$winmm->play;
sleep (1);
$winmm->volume(100);
$winmm->close;

if ( -f $fichier_Log_Desktop ) {
	unlink $fichier_Log_Desktop;
}
if ( ( $Fail or $Process{GLOBAL}{Info} eq 'OUI' ) and !-f $fichier_Log_Desktop ) {
	copy ($fichier_Log, $fichier_Log_Desktop);
}

if ( $OptPerl eq 'perl') {
	print "\n\n<Ctrl C> pour sortir\n";
	sleep (3600);
}

exit (0);
#######################################
# Elimination des doublons d'un tableau
sub doublons_grep {
  my ($ref_tabeau) = @_;
  my %hash_sans_doublon;
  return grep { !$hash_sans_doublon{$_}++ } @{$ref_tabeau};
}

###############
# Date et Heure
sub date {
  my $time = shift || time;    #$time par defaut vaut le time actuel
  my ( $seconde, $minute, $heure, $jour, $mois, $annee, $jour_semaine, $jour_annee, $heure_hiver_ou_ete )
    = localtime($time);
  $mois  += 1;
  $annee += 1900;

  # On rajoute 0 si le chiffre est compris entre 1 et 9
  foreach ( $seconde, $minute, $heure, $jour, $mois, $annee ) { s/^(\d)$/0$1/; }
  return "Le $jour/$mois/$annee à $heure:$minute:$seconde";
}

#####################
# Gestion des erreurs
sub Log {
	my ( $Message ) = @_;
	print LOG $Message;
	print "$Message";
}

###########################################
# Pour avoir les accents sur la console DOS
sub ActiverAccentDOS {
  my ($codepage) = ( `chcp` =~ m/:\s+(\d+)/ );
  foreach my $h ( \*STDOUT, \*STDERR, \*STDIN ) {
    binmode $h, ":encoding(cp$codepage)";
  }
}