#!/usr/bin/perl
use strict;
use warnings;
use utf8;
use Carp;																	# Gestion des erreurs de syntaxe
use File::Path;														# Gestion des répertoires
use File::Copy;														# Pour faire des copy de fichiers
use File::Copy::Recursive qw(fcopy rcopy dircopy fmove rmove dirmove); # Copie récursive de répertoires
use File::Spec;														# Gestion des noms des chemins sous tous les OS
use Getopt::Long;													# Gestion des paramètres passés en ligne de commande
use Config::Std;													# Lecture/ecriture d'un fichier .ini
use Mail::IMAPClient;											# Pour accéder aux messageries
use MIME::Parser;													# Pour parser le message
use Win32::MediaPlayer;										# Pour jouer un fichier son
use Crypt::CBC;														# Pour décrypter mot de passe
use Encode qw(decode);										# Pour décoder From & Subject
use Encode;																# Pour encoder en iso-8859-16
my $winmm = new Win32::MediaPlayer;				# Pour jouer les sons

my ( $SyntVocal ) = "";
GetOptions(
  'SyntVocal' => \$SyntVocal,							# Option pour lancement manuel avec synthèse vocale  --SyntVocal
);
my $FALSE = 0;
my $TRUE  = 1;
my $RepBase               = 'C:/Mail';
my $RepTmp                = 'C:/Mail/Tmp/';
my $RepSav                = 'C:/Mail/Sav/';
my $fichier_Ano           = File::Spec->catfile( $RepBase, 'MAIL.ano' );
my $fichier_Bal           = File::Spec->catfile( $RepTmp,  'BAL.txt' );
my $fichier_Son           = File::Spec->catfile( $RepBase, 'Mail.mp3' );
my $fichier_Notif         = File::Spec->catfile( $RepBase, 'NOTIF.mail' );
my $fichier_Crypt         = File::Spec->catfile( $RepBase, 'Crypt/CRYPT.txt' );
my $fichier_Notif_Desktop = File::Spec->catfile( 'C:/Users/Michel/Desktop', 'NOTIF.mail' );
my $fichier_Ano_Desktop   = File::Spec->catfile( 'C:/Users/Michel/Desktop', 'MAIL.ano' );
my ( $Fail, $Notif ) = 0;
my ( $FicSon, $Balabolka, $ComBalabolka ) = ();
my $Executable	 = 'C:/Program Files (x86)/Balabolka/balabolka.exe';
my $ParamLigne	 = '-rmnq';
my $ParamFichier = '-rmq';

ActiverAccentDOS();

if ( -f $fichier_Ano_Desktop ) {
	open(ANO,'>>:utf8', $fichier_Ano)
		or die Ano("Erreur sur ouverture fichier Ano : $fichier_Ano : \n\t $! \n");
	} else {
		open(ANO,'>:utf8', $fichier_Ano)
			or die Ano("Erreur sur ouverture fichier Ano : $fichier_Ano : \n\t $! \n");
}
if ( -f $fichier_Notif_Desktop ) {
	open(NOTIF,'>>:utf8', $fichier_Notif)
		or die Ano("Erreur sur extension fichier Notif : $fichier_Notif : \n\t $! \n");
	} else {
		open(NOTIF,'>:utf8', $fichier_Notif)
			or die Ano("Erreur sur création fichier Notif : $fichier_Notif : \n\t $! \n");
}

# Pour décryptage mot de passe
open(CRYPT,'<', $fichier_Crypt)
	or die Ano("Erreur sur ouverture fichier Crypt : $fichier_Crypt : \n\t $! \n");		
my $Crypt = <CRYPT>;
close CRYPT;
my $cipher = Crypt::CBC->new( -key => $Crypt, -cipher => 'Blowfish', -iv => 'randomXY', -header => 'none' );

# Le progamme veille.pl a positionné Flag.txt ! On veut la paix... on sort !
my $Fichier_Flag = File::Spec->catfile( $RepBase, 'Flag.txt' );
if ( -f $Fichier_Flag ) {
	exit;
}

# Date_Heure où c'est nécessaire
my ( $Date_Heure, $DatRep ) = date();
Ano ("\n$Date_Heure\n");
Ano ("########################\n");
print NOTIF "\n$Date_Heure\n";
print NOTIF "########################\n";

# Lecture du fichier de configuration
my $Mail = File::Spec->catfile( $RepBase, 'Mail.ini' );
my %Mail_Ini;
if ( -e $Mail ) {
  read_config $Mail => %Mail_Ini;
}
else {
  %Mail_Ini = (
  	'GLOBAL'							=> {
  		Debug								=> 'NON',
  		Batterie						=> 'OUI',
  		Process							=> 'OUI',
  		SyntVocal						=> 'NON',
  		FicSon							=> 'OUI',
  		DateDernierControle => 'Rien',
  		Bals								=> 'TOTO_FREE TATA_YAHOO TITI_ORANGE TUTU_GMAIL',
  	},
    'TOTO_FREE' 	=> {
      Notif						=> 'OUI',
			Pop3						=> 'pop.free.fr',
			Imap						=> 'imap.free.fr',
			Adresse					=> 'toto@free.fr',
			Pwd							=> '',
			Timeout					=> 5,
			Port						=> 993,
			Ssl							=> 1,
			ListDossiers		=> '',
			DossConsults		=> 'INBOX',
			DossPurges			=> '',
			FicMp3					=> 'Toto_free.mp3',
			FicSon					=> 'OUI',
			NbTotMsg				=> 0,
			NbNonLus				=> 0,
			SyntNbTotMsg		=> 'OUI',
			SyntNbNonLus		=> 'OUI',
			SyntFrom				=> 'OUI',
			SyntObj					=> 'OUI',
			SyntTxt					=> 'OUI',
			NbLigne					=> 3,
			SavFic					=> 'OUI',
			SupRep					=> 2,
			ReFlag					=> 'OUI',
    },
    'TATA_YAHOO'	=> {
      Notif						=> 'OUI',
      Pop3						=> 'pop.mail.yahoo.fr',
			Imap						=> 'imap.mail.yahoo.com',
			Adresse					=> 'tata@yahoo.fr',
			Pwd							=> '',
			Timeout					=> 5,
			Port						=> 993,
			Ssl							=> 1,
			ListDossiers		=> '',
			DossConsults		=> 'INBOX',
			DossPurges			=> '',
			FicMp3					=> 'Tata_free.mp3',
			FicSon					=> 'OUI',
			NbTotMsg				=> 0,
			NbNonLus				=> 0,
			SyntNbTotMsg		=> 'OUI',
			SyntNbNonLus		=> 'OUI',
			SyntFrom				=> 'OUI',
			SyntObj					=> 'OUI',
			SyntTxt					=> 'OUI',
			NbLigne					=> 3,
			SavFic					=> 'OUI',
			SupRep					=> 2,
			ReFlag					=> 'OUI',
    },
    'TITI_ORANGE'	=> {
      Notif						=> 'OUI',
      Pop3						=> 'pop.orange.fr',
			Imap						=> 'imap.orange.fr',
			Adresse					=> 'titi@orange.fr',
			Pwd							=> '',
			Timeout					=> 5,
			Port						=> 993,
			Ssl							=> 1,
			ListDossiers		=> '',
			DossConsults		=> 'INBOX',
			DossPurges			=> '',
			FicMp3					=> 'Titi_free.mp3',
			FicSon					=> 'OUI',
			NbTotMsg				=> 0,
			NbNonLus				=> 0,
			SyntNbTotMsg		=> 'OUI',
			SyntNbNonLus		=> 'OUI',
			SyntFrom				=> 'OUI',
			SyntObj					=> 'OUI',
			SyntTxt					=> 'OUI',
			NbLigne					=> 3,
			SavFic					=> 'OUI',
			SupRep					=> 2,
			ReFlag					=> 'OUI',
    },
    'TUTU_GMAIL'	=> {
      Notif						=> 'NON',
      Pop3						=> 'pop.gmail.com',
			Imap						=> 'imap.googlemail.com',
			Adresse					=> 'tutu@gmail.com',
			Pwd							=> '',
			Timeout					=> 5,
			Port						=> 993,
			Ssl							=> 1,
			ListDossiers		=> '',
			DossConsults		=> 'INBOX',
			DossPurges			=> '',
			FicMp3					=> 'Tutu_free.mp3',
			FicSon					=> 'OUI',
			NbTotMsg				=> 0,
			NbNonLus				=> 0,
			SyntNbTotMsg		=> 'OUI',
			SyntNbNonLus		=> 'OUI',
			SyntFrom				=> 'OUI',
			SyntObj					=> 'OUI',
			SyntTxt					=> 'OUI',
			NbLigne					=> 3,
			SavFic					=> 'OUI',
			SupRep					=> 2,
			ReFlag					=> 'OUI',
    },
  );
}

# Mise à jour de DateDernierControle dans fichier.ini & récupération de toutes les BAL
$Mail_Ini{GLOBAL}{DateDernierControle} = $Date_Heure;
my @Bals = split (/\n/,$Mail_Ini{GLOBAL}{Bals});

Ano ( "\nContrôle des boîtes à lettres\n" );
if ( $Mail_Ini{GLOBAL}{FicSon} eq 'OUI' ) {
	$FicSon = File::Spec->catfile( $RepBase, 'bells_up.mp3');
	$winmm->load($FicSon);
	$winmm->play;
	sleep (4);
	$winmm->volume(80);
	$winmm->close;
}
foreach my $Bal ( @Bals ) {
	if ( $Mail_Ini{GLOBAL}{Debug} eq 'OUI' ) {
		print "\n";
		print "BAL               = $Bal \n";
		print "NOTIF             = $Mail_Ini{$Bal}{Notif} \n";
		print "IMAP              = $Mail_Ini{$Bal}{Imap} \n";
		print "ADRESSE           = $Mail_Ini{$Bal}{Adresse} \n";
		print "PWD               = $Mail_Ini{$Bal}{Pwd} \n";
		print "TIMEOUT           = $Mail_Ini{$Bal}{Timeout} \n";
		print "PORT              = $Mail_Ini{$Bal}{Port} \n";
		print "SSL               = $Mail_Ini{$Bal}{Ssl} \n";
		print "NBTOTMSG          = $Mail_Ini{$Bal}{NbTotMsg} \n";
		print "LISTDOSSIERS      = $Mail_Ini{$Bal}{ListDossiers} \n";
		print "DOSSIERSCONSULTES = $Mail_Ini{$Bal}{DossConsults} \n";
		print "DOSSIERSPURGES    = $Mail_Ini{$Bal}{DossPurges} \n";
		print "FICMP3            = $Mail_Ini{$Bal}{FicMp3} \n";
		print "FICSON            = $Mail_Ini{$Bal}{FicSon} \n";
		print "NBTOTMSG          = $Mail_Ini{$Bal}{NbTotMsg} \n";
		print "NBNONLUS          = $Mail_Ini{$Bal}{NbNonLus} \n";
		print "SYNTNBTOTMSG      = $Mail_Ini{$Bal}{SyntNbTotMsg} \n";
		print "SYNTNBNONLUS      = $Mail_Ini{$Bal}{SyntNbNonLus} \n";
		print "SYNTFROM          = $Mail_Ini{$Bal}{SyntFrom} \n";
		print "SYNTOBJ           = $Mail_Ini{$Bal}{SyntObj} \n";
		print "SYNTTXT           = $Mail_Ini{$Bal}{SyntTxt} \n";
		print "NBLIGNE           = $Mail_Ini{$Bal}{NbLigne} \n";
		print "SAVFIC            = $Mail_Ini{$Bal}{SavFic} \n";
		print "REFLAG            = $Mail_Ini{$Bal}{ReFlag} \n";
	}
		
	if ( ! $Mail_Ini{$Bal}{Notif} ) {
		Ano("Absence de paramètre Notif $Bal\n");
		$Fail++,
		next;
	}
	
	my ( $NbTotMsg, $NbNonLus, ) = 0;
	my ( $Msg ) = "";
	print NOTIF "\n" .$Bal ." :\n";
	if ( $Mail_Ini{$Bal}{Notif} eq 'OUI' ) {
			my $imap = Mail::IMAPClient->new( 
				Server 	 => $Mail_Ini{$Bal}{Imap},
				User     => $Mail_Ini{$Bal}{Adresse},
				Password => $cipher->decrypt_hex($Mail_Ini{$Bal}{Pwd}),
				Timeout  => $Mail_Ini{$Bal}{Timeout},
				Port     => $Mail_Ini{$Bal}{Port},
				Ssl      => $Mail_Ini{$Bal}{Ssl},
				Debug	   => 0,
			) or die Ano("Erreur connexion sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
					$Fail++, next;
		
		# Liste de tous les dossiers de la BAL
		my @ListDossiers = $imap->folders
			or die Ano("Erreur FOLDERS sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
				$Fail++, next;
		$Mail_Ini{$Bal}{ListDossiers} = join("\n",@ListDossiers);
		write_config %Mail_Ini, $Mail;
		
		# Traitement des dossiers à contrôler : INBOX ...
		my @Dossiers = split (/\n/,$Mail_Ini{$Bal}{DossConsults});
		foreach my $Dossier ( @Dossiers ) {
			$imap->select($Dossier)
				or die Ano("Erreur SELECT $Dossier sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
					$Fail++, next;
			$imap->Ignoresizeerrors($TRUE) # Nécessaire pour Yahoo sinon : Erreur MESSAGE_STRING INBOX sur imap.mail.yahoo.com ; message_string() expected 103556 bytes but received 103639 you may need the IgnoreSizeErrors option
				or die Ano("Erreur IGNORESIZEERRORS $Dossier sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
					$Fail++, next;
			$NbTotMsg = $imap->message_count($Dossier);
			if ( ! $NbTotMsg ) {
				$Mail_Ini{$Bal}{NbTotMsg} = $NbTotMsg;
				write_config %Mail_Ini, $Mail;
				next;
			}
			
    	print NOTIF "\n". $NbTotMsg ." Courrier(s) au total dans ". $Dossier ." sur ". $Mail_Ini{$Bal}{Adresse} ."\n";
			$Msg = "\nIl y a : " .$NbTotMsg. " Courrier(s) au total dans ". $Dossier ." sur ". $Mail_Ini{$Bal}{Adresse}."\n";
			Ano ( $Msg );	
			if ( ( $SyntVocal || $Mail_Ini{GLOBAL}{SyntVocal} eq 'OUI' ) && $Mail_Ini{$Bal}{SyntNbTotMsg} eq 'OUI' ) {					
				$Balabolka    = '"'. $Msg .'"';
				my @Cde = ( $Executable , $ParamLigne , $Balabolka );
				system @Cde;
			}
		
			$NbNonLus = $imap->unseen_count($Dossier);
			if ( $NbNonLus > 0 ) {
				$Msg = "\n\nIl y a : " .$NbNonLus. " courrier(s) non consulté(s) sur $Mail_Ini{$Bal}{Adresse}\n";
				Ano ( $Msg );
				print NOTIF "\tdont " .$NbNonLus. " courrier(s) non consulté(s):\n";
				if ( ( $SyntVocal || $Mail_Ini{GLOBAL}{SyntVocal} eq 'OUI' ) && $Mail_Ini{$Bal}{SyntNbNonLus} eq 'OUI' ) {			
					$Msg = encode("iso-8859-16", $Msg);
					$Balabolka    = '"'. $Msg .'"';
					my @Cde = ( $Executable , $ParamLigne , $Balabolka );
					system @Cde;
				}
			} else {
				next;
			}
		
			# Préparation du son à jouer puisqu'il y a nouveau(x) message(s)
			$FicSon = File::Spec->catfile( $RepBase, 'Generique.mp3');
			if ( -f $Mail_Ini{$Bal}{FicMp3} ) {
				$FicSon = File::Spec->catfile( $RepBase, $Mail_Ini{$Bal}{FicMp3});
			} 
		
			# Traitement des nouveaux messages
  		my @Courriers = $imap->unseen()
  			or die Ano("Erreur UNSEEN $Dossier sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
					$Fail++, next;
  		foreach my $Courrier (@Courriers) {
  			$Notif++;  			
    		my $string = $imap->message_string($Courrier)
    			or die Ano("Erreur MESSAGE_STRING $Dossier sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
						$Fail++, next;
    		# Récupération et traitement From & Subject
    		# print "\n#######################################################\n";
    		my $From = $imap->get_header($Courrier, "From")
    			or die Ano("Erreur GET_HEADER FROM $Dossier sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
						$Fail++, next;
    		$From = decode("MIME-Header", $From);
    		$From = encode("iso-8859-16", $From);
    		$From = "\n\tEnvoyé par : ".$From;
				print NOTIF "$From";
			
				my $Subject = $imap->get_header($Courrier, "Subject")
					or die Ano("Erreur GET_HEADER SUBJECT $Dossier sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
						$Fail++, next;
    		$Subject = decode("MIME-Header", $Subject);
    		$Subject = "\n\tObjet : ".$Subject;
    		print NOTIF "$Subject\n";
    		
    		my $parser = new MIME::Parser
    			or die Ano("Erreur MIME::PARSER $Dossier sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
						$Fail++, next;
				if ( !-d $RepTmp.$Bal ) {
					mkdir $RepTmp.$Bal;
				}
				mkdir $RepTmp.$Bal.$DatRep;
				$parser->output_under($RepTmp.$Bal.$DatRep)
					or die Ano("Erreur OUTPUT_UNDER $Dossier sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
						$Fail++, next;
				my $entity = $parser->parse_data($string)
					or die Ano("Erreur PARSE_DATA $Dossier sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
						$Fail++, next;
				
				# Sauvegarde des fichiers temporaires
				if ( $Mail_Ini{$Bal}{SavFic} eq 'OUI' ) {
					dircopy($RepTmp.$Bal.$DatRep,$RepSav.$Bal.$DatRep)
						or die Ano ("Impossible de copier $RepTmp.$Bal.$DatRep :\n\t $! - $@\n"), $Fail++;
					my @Fichiers = lister_fichiers ($RepTmp.$Bal.$DatRep, 1);
					@Fichiers = grep { !/(.txt$)|(.html$)/ } @Fichiers;
					if( @Fichiers ){
						print NOTIF "\t\t ATTENTION : il y a des pièces jointes à ce courrier !\n";
  					print "\a \a \a \a";
					}
				}
				
				if ( $Mail_Ini{$Bal}{ReFlag} eq 'OUI' ) {
					$imap->unset_flag("Seen",@Courriers)
						or die Ano("Erreur UNSET_FLAG $Dossier sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
							$Fail++, next;
				}
    		
    		# Traitement du courrier en synthèse vocale 		
    		if ( $SyntVocal || $Mail_Ini{GLOBAL}{SyntVocal} eq 'OUI' ) {
    			open(BAL,">", $fichier_Bal) 			# NB '>' car lisible par Balabolka (pas utf8 !)	
						or die Ano("Erreur sur ouverture fichier Bal : $fichier_Bal :\n\t $! - $@\n"),	$Fail++;
    	 		
    			if ( $From && $Mail_Ini{$Bal}{SyntFrom} eq 'OUI' ) {		
						# ORIGINE $From			
						$From =~ s/>/ /g;                 # Si <@> balabolka ne prononce pas !
						$From =~ s/ </, /g;               # 
						$From =~ s/'//g;									# supprime les '
						$From =~ s/"//g;									# supprime les "
						$From =~ s/\s+/ /g;               # supprime plus de 2 espaces consécutifs
						$From =~ s/^\s//;                 # supprime espace en début de ligne
					
						Ano ( "\n\n".$From );
						print BAL "\nCourrier non consulté : \n". $From ." : \n";
					}
			
					if ( $Subject && $Mail_Ini{$Bal}{SyntObj} eq 'OUI' ) {		
						# OBJET $Subject ATTENTION VOIR LIB AVEC DES EUROS ex 100€  \x{0080}
						$Subject =~ s/Re: /Réponse à : /;
						$Subject =~ s/\// par /;
						$Subject =~ s/\s+/ /g;           # supprime plus de 2 espaces consécutifs
						$Subject =~ s/^\s//;             # supprime espace en début de ligne
						$Subject =~ s/\x{20ac}/\x{80}/;  # $Subject =~ s/\x{20ac}/ Euros /; Car "iso-8859-16" Not OK \x{80}=€
												
						Ano ( "\n".$Subject );
						$Subject = encode("iso-8859-16", $Subject); # OK sauf € même avec "iso-8859-11" ou "iso-8859-16"
						print BAL $Subject ." : \n";
    			}
    	
    			if ( $Mail_Ini{$Bal}{SyntTxt} eq 'OUI' ) { 		
						# Toutes les entitées du BODY
						my @Fichiers = lister_fichiers( $RepTmp.$Bal, 1 );
						@Fichiers = grep { /(.txt$)/ } @Fichiers;
						foreach my $Fichier ( @Fichiers ) {
							open IN_Fic,'<:utf8', $Fichier
  							or die "Impossible d'ouvrir le repertoire $Fichier :\n\t $! - $@\n";
  						my $i = 0;
  						print BAL "\nTexte : ";
  						while ( my $Ligne = <IN_Fic> ) {  							
  							$Ligne =~ s/<.+\n*.*?>//g;    # supprime les tag html <>
  							next if $Ligne =~ /^\s+$/;    # supprime lignes vides
  							next if $Ligne =~ /^=+$/;     # supprime les lignes de = consécutifs
  							next if $Ligne =~ /^-+$/;     # supprime les lignes de - consécutifs
  							next if $Ligne =~ /^\*+$/;    # supprime les lignes de * consécutifs
  							$Ligne =~ s/\s+/ /g;          # supprime plus de 2 espaces consécutifs
  							$Ligne =~ s/^\s//;            # supprime espace en début de ligne
  							next if $Ligne =~ /^\.$/;     # supprime ligne qui ne contient qu'un point
  							next if $Ligne =~ /^\.\s$/;   # supprime ligne qui ne contient qu'un point suivi d'un espace
  							next if $Ligne =~ /^\.\s$/;   # supprime ligne qui ne contient qu'un point suivi d'espaces

  							print BAL $Ligne."\n";
  							$i++;
  							if ( $i > $Mail_Ini{$Bal}{NbLigne} ) {
  								last;
  							}
							}
							close IN_Fic;
						}
					}
					close BAL;
					my @Cde = ( $Executable , $ParamFichier , $fichier_Bal );
					system @Cde;
					unlink $fichier_Bal;
				} # Fin synthèse vocale pour 1 $Courrier
				
				$parser->filer->purge;
				rmtree ( [$RepTmp.$Bal] );
				
			} # Fin Traitement des nouveaux messages @msgs

			if ( $Dossier eq 'INBOX' && $NbNonLus && $Mail_Ini{$Bal}{FicSon} eq 'OUI' ) {
				Ano ("\n\nIl y a de nouveau(x) courrier(s) sur $Mail_Ini{$Bal}{Adresse}\n");
				$winmm->load($FicSon);
				$winmm->play;
				sleep (8);
				$winmm->volume(100);
				$winmm->close;
			}
			if ( $Dossier eq 'INBOX' ) {
				$Mail_Ini{$Bal}{NbTotMsg} = $NbTotMsg;
				$Mail_Ini{$Bal}{NbNonLus} = $NbNonLus;
				write_config %Mail_Ini, $Mail;
			}
			$imap->close 
				or die Ano("Erreur CLOSE $Dossier sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
					$Fail++, next;
		} # Fin des dossiers à contrôler : INBOX ... pour 1 BAL
		
		# Purge des dossiers
		if ( $Mail_Ini{$Bal}{DossPurges} ) {
			my @DossPurges = split (/\n/,$Mail_Ini{$Bal}{DossPurges});
			foreach my $DossPurge ( @DossPurges ) {
				$imap->select($DossPurge)
					or die Ano("Erreur SELECT $DossPurge sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
						$Fail++, next;
				my $NbPurgMsg = $imap->message_count($DossPurge);
				next if $NbPurgMsg == 0;
				print NOTIF "\nPurge de " .$Bal ." :";
    		print NOTIF "\n". $NbPurgMsg ." Courrier(s) à purger dans ". $DossPurge ." sur ". $Mail_Ini{$Bal}{Adresse} ."\n";
				
				my @purges = $imap->seen()
					or die Ano("Erreur SEEN $DossPurge sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
						$Fail++, next;
			  scalar(@purges) and $imap->delete_message(\@purges)
    			or die Ano("Erreur DELETE_MESSAGE $DossPurge sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
						$Fail++, next;	
				print NOTIF $DossPurge ." purgé sur ". $Mail_Ini{$Bal}{Adresse} ."\n";
				$Msg = $DossPurge ." purgé sur ". $Mail_Ini{$Bal}{Adresse}."\n";
				Ano ( $Msg );
				$imap->close
					or die Ano("Erreur CLOSE $DossPurge sur $Mail_Ini{$Bal}{Imap} $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
						$Fail++, next;
			}
		}
		
		# Fin d'une BAL, on sort
		$imap->logout()
			or die Ano("\nErreur LOGOUT sur $Mail_Ini{$Bal}{Adresse} :\n\t $! - $@\n"),
				$Fail++, next;	
	} else {
		Ano ("\n\t\t\t\t\t$Mail_Ini{$Bal}{Adresse} non consultée\n");
		print NOTIF "\t\t\t\t\t$Mail_Ini{$Bal}{Adresse} non consultée\n";
	}
	
	# Suppression des répertoires anciens sauvegardés
	if ( -d $RepSav.$Bal && $Mail_Ini{$Bal}{SupRep} > 0 ) {
		SupRep ( $RepSav.$Bal, $Mail_Ini{$Bal}{SupRep} );
	}
	
} # Fin de toutes les @Bals à contrôler

if ( $Mail_Ini{GLOBAL}{FicSon} eq 'OUI' ) {
	$FicSon = File::Spec->catfile( $RepBase, 'bells_down.mp3');
	$winmm->load($FicSon);
	$winmm->play;
	sleep (4);
	$winmm->volume(80);
	$winmm->close;
}

if ( $Mail_Ini{GLOBAL}{Batterie} eq 'OUI' ) {
	Ano ("\n\n===================================================================\n");
	Ano ("\n\n                         CONTROLE BATTERIE                         \n");
	my @Cde = ("C:\\Perl\\bin\\perl.exe C:\\Mail\\Batterie.pl");
  system @Cde;
}
if ( $Mail_Ini{GLOBAL}{Process} eq 'OUI' ) {
	Ano ("\n\n===================================================================\n");
	Ano ("\n\n                      CONTROLE DES  PROCESSUS                      \n");
	my @Cde = ("C:\\Perl\\bin\\perl.exe C:\\Mail\\Kill_Process.pl --OptPerl wperl");
  system @Cde;
}
Ano ("\n\n=============================== F I N ===============================\n");

close (ANO);
print NOTIF "\n";
close (NOTIF);
if ( -f $fichier_Notif_Desktop ) {
	unlink $fichier_Notif_Desktop;
}
if ( $Notif ) {
	copy ($fichier_Notif, $fichier_Notif_Desktop);
}

if ( -f $fichier_Ano_Desktop ) {
	unlink $fichier_Ano_Desktop;
}
if ( $Fail ) {
	copy ($fichier_Ano, $fichier_Ano_Desktop);
}
close (BAL);

exit (0);	

######################
# Gestion des messages
######################
sub Ano {
	my ( $Message ) = @_;
	print ANO $Message;
	print "$Message";
}

###############################################
# Suppression des répertoires avec leur contenu
###############################################
sub SupRep {
	my ( $Repertoire, $NbJours ) = @_;
	my $Time = time;
	my $Seconde = 24 * 3600;
	if ( not defined $NbJours or not defined $Repertoire ) {
  	Ano("\n\t\t\tOptions manquantes dans SupRep -$Repertoire-$NbJours-\n"),
  		$Fail++, return;
	}
	opendir my $FhRep, $Repertoire or die ("impossible d'ouvrir le répertoire $Repertoire :\n\t $! \n"),
		$Fail++, return;
	my @Reps = grep { !/^\.\.?$/ } readdir($FhRep);
	my $Msg = "\n\t\tSuppression des répertoires de plus de $NbJours jours :";
	foreach my $Rep ( @Reps ) {
		$Rep = $Repertoire. "/" .$Rep;
  	my $Mtime = ( stat($Rep) )[9];
  	my $Diff = int( ( $Time - $Mtime ) / $Seconde );
  	if ( ($Diff >= $NbJours) ) {
    	rmtree $Rep or die Ano("Impossible de supprimer $Rep :\n\t $! \n"),
    		$Fail++, return;
    	$Msg = $Msg ."\n\t\t\t- $Rep supprimé";
    	print NOTIF $Msg;
    	print $Msg;
    	$Notif++;
  	}
  	$Msg = "";
  }
  closedir $FhRep;
  opendir $FhRep, $Repertoire or die ("impossible d'ouvrir le répertoire $Repertoire :\n\t $! \n"),
		$Fail++, return;
  my $Nb = @Reps = grep { !/^\.\.?$/ } readdir $FhRep;
  if ( $Nb ) {
  	print NOTIF "\n\t\t\t\t+ $Repertoire contient encore $Nb répertoire(s).\n";
	} else {
		print NOTIF "\n\t\t\t- $Repertoire vide et donc supprimé !\n";
  	rmtree $Repertoire or die Ano("Impossible de supprimer $Repertoire :\n\t $! \n"),
    		$Fail++, return;
	}
  closedir $FhRep;
}

#==================================================================
# Nombre d'arguments : 1 ou 2
# Argument(s)        : un répertoire et valeur 0 ou 1
# Retourne           : Tableau de fichier (@fichiers)
# http://perl.developpez.com/faq/perl/?page=section1#ListerFichiers
#==================================================================
sub lister_fichiers {
  my ( $repertoire, $recursivite ) = @_;
  require Cwd;
  require File::Spec;
  my $cwd = Cwd::getcwd();
  if ( ( not defined $recursivite ) || ( $recursivite != 1 ) ) { $recursivite = 0; }
  if ( not defined $repertoire ) { die "Aucun repertoire de specifie :\n\t $! \n"; }
  opendir my $fh_rep, $repertoire or die "impossible d'ouvrir le répertoire $repertoire :\n\t $! \n";
  my @fic_rep = grep { !/^\.\.?$/ } readdir $fh_rep;
  closedir $fh_rep or die "Impossible de fermer le répertoire $repertoire :\n\t $! \n";
  chdir $repertoire;
  $repertoire = Cwd::getcwd();
  my @fichiers;
  foreach my $nom (@fic_rep) {
    my $notre_fichier = File::Spec->catfile( $repertoire, $nom );
    if ( -f $notre_fichier ) {
      push @fichiers, $notre_fichier;
    }
    elsif ( -d $notre_fichier and $recursivite == 1 ) {
      push @fichiers, lister_fichiers($notre_fichier, $recursivite);    # recursivité
    }
  }
  chdir $cwd;
  return @fichiers;
}

#==============================================================
# Pour avoir les accents sur la console DOS
# http://perl.developpez.com/faq/perl/?page=Terminal#AccentsDOS
#==============================================================
sub ActiverAccentDOS {
  my ($codepage) = ( `chcp` =~ m/:\s+(\d+)/ );
  foreach my $h ( \*STDOUT, \*STDERR, \*STDIN, ) {
    binmode $h, ":encoding(cp$codepage)";
  }
}

#===================================================================
# Date et Heure (Modifié pour avoir 2 formats en sortie)
# ORIGINAL : http://perl.developpez.com/faq/perl/?page=section3#date
#===================================================================
sub date {
  my $time = shift || time;    #$time par defaut vaut le time actuel
  my ( $seconde, $minute, $heure, $jour, $mois, $annee, $jour_semaine, $jour_annee, $heure_hiver_ou_ete )
    = localtime($time);
  $mois  += 1;
  $annee += 1900;

  # On rajoute 0 si le chiffre est compris entre 1 et 9
  foreach ( $seconde, $minute, $heure, $jour, $mois, $annee ) { s/^(\d)$/0$1/; }
  return ("Le $jour/$mois/$annee à $heure:$minute:$seconde", "/$mois$jour-$heure$minute");
}

################################################################################
=pod		
# Dans le cas text/plain je trouve bien 	$part->bodyhandle->path
# Dans le cas multipart/alternative NON !!!
# Donc je récupère les fichiers autrement !!!
for my $part ($entity->parts()) {
	if ( $Mail_Ini{GLOBAL}{Debug} eq 'OUI' ) {
		print "\nMESTYPE ".$part->mime_type;
	}		
	if ( $part->mime_type eq 'text/plain' ) {
		$FileName = $part->bodyhandle->path;
		if ( $Mail_Ini{GLOBAL}{Debug} eq 'OUI' ) {
			print "\nMYFILENAME/ $FileName";
		}
	}
	if ( $part->mime_type eq 'multipart/alternative' ) {
		print "\nmultipart/alternative\n";
		if ( $entity->parts == 2 ) {
			print "ENTITY_PARTS = 2\n";
		}
		# Où se trouve bodyhandle->path ???
	}
}
=cut
